*DECK EDIDRV
      SUBROUTINE EDIDRV(IPEDIT,IPFLUX,IPLIB ,IPSYS ,IPGEO1,IPGEO2,
     >                  MAXPTS,MAXISO,CDOOR ,NGROUP,NBMIX ,NREGIO,
     >                  LEAKSW,NWGTH ,NIFISS,NEDMAC,CTITRE,NL    ,
     >                  ITRANC,NGCOND,NMERGE,IFFAC ,ILUPS ,NSAVES,
     >                  NSTATS,CURNAM,OLDNAM,NSPH  ,KSPH  ,CNDOOR,
     >                  NBMICR,NACTI ,IPRINT,NTENER,IXEDI ,ISOTXS,
     >                  MATCOD,VOLUME,KEYFLX,IGCOND,IMERGE,ISOCAR,
     >                  IACTI ,FLUXES,ENERGY,ENERV ,ISONAM)
C
C-------------------------    EDIDRV    -------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIDRV
C      USE      : OPTIONAL EQUIVALENCE SPH CALCULATION,
C                 FLUX AND REACTION RATES EDITION,
C                 STATISTICAL ANALYSIS, FOUR FACTOR CALCULATION
C      MODIFIED : 99-02-19 (G.M.)
C                 -> COMPUTE DIRECTIONAL WEIGHTING FACTOR TO
C                    CORRECT BUCKLING WEIGHTED ANISOTROPIC SCATTERING
C                 97-02-06 (G.M.)
C                 94-11-23 (A.H.)
C                 91-12-04 (G.M.)
C                 91-04-03 (G.M.)
C                 89-09-23 (G.M.)
C                 88-08-23 (A.H.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C      IPEDIT   : POINTER TO THE EDIT                    I
C      IPFLUX   : POINTER TO THE SOLUTION                I
C      IPLIB    : POINTER TO THE INTERNAL LIBRARY        I
C                 OR MACROLIB
C      IPSYS    : POINTER TO THE PIJ (ONLY USED WITH     I
C                 SELENGUT NORMALIZATION)
C      IPGEO1   : POINTER TO THE ORIGINAL GEOMETRY       I
C      IPGEO2   : POINTER TO THE MACRO GEOMETRY          I
C      MAXPTS   : MAXIMUM NUMBER OF MACRO-REGIONS        I
C      MAXISO   : MAXIMUM NUMBER OF ISOTOPES             I
C      CDOOR    : REFERENCE GEOMETRY TRACKING MODULE     C*12
C      NGROUP   : NUMBER OF GROUPS                       I
C      NBMIX    : NUMBER OF MIXTURES                     I
C      NREGIO   : NUMBER OF REGIONS                      I
C      LEAKSW   : LOGICAL FOR LEAKAGE                    L
C      NWGTH    : P1 SCATTERING MERGE OPTION             I
C                 = 0 FLUX
C                 = 1 CURRENT
C                 = 2 BUCKLING-WEIGHTED COHERENT
C                 = 3 BUCKLING-WEIGHTED COHERENT
C                     AND DIRECTIONAL CORRECTION
C      NIFISS   : NUMBER FISSILE ISOTOPES                I
C      NEDMAC   : NUMBER OF EXTRA MACRO X-S              I
C      CTITRE   : EXECUTION TITLE                        C*72
C      NL       : NUMBER OF LEGENDRE ORDERS              I
C      ITRANC   : TYPE OF TRANSPORT CORRECTION           I
C      NGCOND   : NUMBER OF CONDENSED GROUPS             I
C      NMERGE   : NUMBER OF REGIONS MERGED               I
C      IFFAC    : FOUR FACTOR CALCULATION                I
C                 = 0 NO FOUR FACTORS (DEFAUT)
C                 = 1 FOUR FACTOR EVALUATION
C      ILUPS    : REMOVE UP-SCATTERING FROM OUTPUT       I
C      NSAVES   : HOMOGENIZED X-S COMPUTATION+SAVE       I
C                 = 0  NO COMPUTE NO SAVE
C                 = 1  COMPUTE, NO SAVE
C                 = 2  COMPUTE, SAVE
C                 = 3  COMPUTE, SAVE MICRO PERTURBATION
C      NSTATS   : STATISTICS LEVEL                       I
C                 = 0  NO STATS
C                 = 1  STATISTICS ON FLUXES
C                 = 2  STATISTICS ON REACTION RATES
C                 = 3  STATISTICS ON FLUXES + RR
C                 =-1  DELTA SIGMA (MERG COMP ONLY)
C      CURNAM   : NAME OF LCM DIRECTORY WHERE THE
C                 CURRENT RATES ARE TO BE STORED         C*12
C      OLDNAM   : NAME OF LCM DIRECTORY WHERE OLD
C                 RATES WERE STORED                      C*12
C      NSPH     : TYPE OF SPH MACRO CALCULATION          I
C      KSPH     : TYPE OF SPH NORMALIZATION              I
C      CNDOOR   : TYPE OF SPH MACRO-CALCULATION          C*12
C      NBMICR   : <-1: GENERATE FULL XS LIBRARY          I
C                      INCLUDING DEPLETION CHAIN AND
C                      INDEPENDANT FISSION SPECTRUM FOR
C                      (-NBMICR-1) SELECTED ISOTOPES
C                 =-1: GENERATE FULL XS LIBRARY
C                      INCLUDING DEPLETION CHAIN AND
C                      INDEPENDANT FISSION SPECTRUM FOR
C                      ALL ISOTOPES
C                 =0 : DO NOT GENERATE MICROSCOPIC
C                      XS LIBRARY
C                 =1:  PROCESS ALL ISOTOPE XS
C                 >1:  PROCESS (NBMICR-1)
C                      SELECTED ISOTOPES
C      NACTI    : NUMBER OF ACTIVATION EDIT              I
C      IPRINT   : PRINT INDEX                            I
C      NTENER   : ENERGY PRESENCE INDEX                  I
C      IXEDI    : FIRST ISOTXS RECORD NUMBER             I
C                 =0 NONE ;=1 FOR ISOTXS ; =2 FOR TAPE16
C      ISOTXS   : ISOTXS ADDITIONAL EDIT FORMAT          I(2)
C                 ISOTXS(1) IS FOR FLIB OR MIC
C                 ISOTXS(2) IS FOR ACTI
C                 =0 NONE ;=1 FOR ISOTXS
C
C      MATCOD   : MIXTURE INDEX IN REGION                I(NREGIO)
C      VOLUME   : VOLUME OF REGION                       R(NREGIO)
C      KEYFLX   : AVERAGE FLUX POSITION PER REGION       I(NREGIO)
C      IGCOND   : CONDENSED GROUPS LIMITS                I(NGROUP)
C      IMERGE   : MERGED REGIONS POSITION                I(NREGIO)
C      ISOCAR   : NAMES OF THE ISOTOPES TO PROCESS       I(2,MAXISO)
C      IACTI    : ACTIVATION MIXTURES                    I(NBMIX)
C      FLUXES   : FLUXES                             R(NREGIO*NGROUP)
C      ENERGY   : ENERGY/LETHARGY                        R(2*NGCOND+1)
C      ENERV    : AVERAGE ENERGY                         R(NGROUP)
C      ISONAM   : NAMES OF THE LIBRARY ISOTOPES          I(3,MAXISO)
C
C---------------------------   EDIDRV  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE,NTC,ILCMUP,ILCMDN,MAXED,NDPROC,MAXR,
     >            NMSTEP,ITGOXS
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NSTATE=20,NTC=3,ILCMUP=1,ILCMDN=2,
     >            MAXED=50,NDPROC=20,MAXR=5,NMSTEP=2,ITGOXS=2,
     >            NAMSBR='EDIDRV')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPEDIT,IPFLUX,IPLIB,IPSYS,IPGEO1,IPGEO2,
     >            MAXPTS,MAXISO,NGROUP,NBMIX,NREGIO,NWGTH,NIFISS,
     >            NEDMAC,NL,ITRANC,NGCOND,NMERGE,IFFAC,ILUPS,
     >            NSAVES,NSTATS,NSPH,KSPH,NBMICR,NACTI,IPRINT,
     >            NTENER,IXEDI
      CHARACTER   CDOOR*12,CTITRE*72,CURNAM*12,OLDNAM*12,CNDOOR*12
      INTEGER     ISOTXS(2),MATCOD(NREGIO),KEYFLX(NREGIO),
     >            IGCOND(NGROUP),IMERGE(NREGIO),ISOCAR(2,MAXISO),
     >            IACTI(NBMIX),ISONAM(3,MAXISO)
      LOGICAL     LEAKSW
      REAL        VOLUME(NREGIO),FLUXES(NREGIO*NGROUP),
     >            ENERGY(2*NGCOND+1),ENERV(NGROUP)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     ITAUXT,IDIRC,IVOLME,ISCATD,ISPH,IXSTRD,IFLINT,
     >            IANVEL,IDISFC,MATMC,INAMEA,IFFUEL,IFUELR,IFACT,
     >            INFI,IMFI,IMFF,IDEN,ITMP,IMIX,ISONRF,ISOAWR,IJCEDM,
     >            IEJ,INADPL,IDEPR,JDEPR,IIZAE,IKPAR,IBPAR,IYIELD,
     >            ISIGF,IHFACT,IHFSO,IDFISS,IDPROD,INNAM,INDISO,
     >            INDMIC,IDNUM,IDNUMX,IDTMP,ISOCOD,IDVOL,INNRF,
     >            INMIX,INAWR,INDEN,INTMP,INVOL,ISNEJ,IDFLX,
     >            IDFLG,ITYPRO,LOCISO,IIJJ,INJJ,IOLDFL,IOLDVA,
     >            IVALER,INGSCT,IFGSCT,IPOSCT,ITYPER,IDRATE,
     >            IDLEAK,IFFNFT,IEFIS
C----
C  FUNCTIONS
C----
      INTEGER     KDROPN,KDRCLS
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   HSIGN*12,HVECT(MAXED)*6,NISEXT*6,NISOTX*12,
     >            CTITLE*72
      INTEGER     ISTATE(NSTATE),KCHAR(NTC),IMSTEP(NMSTEP),
     >            ILCMLN,ILCMTY,IED,NDEPL,NED,IDEB,NDFI,NDFP,
     >            NHEAVY,NLIGHT,NOTHER,NBXR,NDIALC,NSSTP,
     >            ISTEP,NELEMT,NELEMD,NTAUXT,ILEAKS,NBISO,
     >            NPROC,IMRG,ICAR,IWGOXS,IRETRN,NBIXS,NBNMIC,
     >            NBNISO,ITC,NCOMB,MXVAL,MXERR
      INTEGER     NGFAST,NGEPTH
      REAL        B2(4),TIMEF(3),EIGENK
C----
C  FIND THE SIGNATURE OF IPLIB
C----
      CALL LCMGET(IPLIB,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
C----
C  ALLOCATE MEMORY FOR GROUP CONDENSATION AND MERGE
C----
      NELEMT=NMERGE*NGCOND
      NELEMD=(1+NMERGE)*NGCOND
      NTAUXT=13+3*NIFISS+NL+NEDMAC+1
      CALL SETARA(RBASE,2*NELEMD*NTAUXT,ITAUXT)
      CALL SETARA(RBASE,2*(NMERGE+1)*(NIFISS+2),IEFIS)
C----
C  99-02-19
C  ALLOCATE DOUBLE PRECISION VECTOR "IDIRC" FOR DIRECTIONAL
C  ANISOTROPIC SCATTERING CORRECTION
C----
      CALL SETARA(RBASE,2*NELEMD*3,IDIRC)
      CALL SETARA(RBASE,2*NMERGE,IVOLME)
      CALL SETARA(RBASE,2*NELEMT*NGCOND*NL,ISCATD)
      CALL SETARA(RBASE,NELEMT,ISPH)
      CALL SETARA(RBASE,2*4*NGCOND*NMERGE,IXSTRD)
C----
C  COMPUTE SPH FACTORS
C----
      IF(NSPH .EQ. 0) THEN
        CALL XDRSET(RBASE(ISPH),NELEMT,1.0)
      ELSE
        IF(HSIGN .EQ. 'L_LIBRARY')
     >    CALL LCMSIX(IPLIB,'MACROLIB',ILCMUP)
        CALL SPHDRV(IPEDIT,IPGEO1,IPGEO2,IPFLUX,IPLIB ,IPSYS ,
     >              MAXPTS,CDOOR ,CNDOOR,IPRINT,ITRANC,NGROUP,
     >              NGCOND,NBMIX ,NREGIO,NMERGE,NIFISS,LEAKSW,
     >              MATCOD,VOLUME,KEYFLX,IGCOND,IMERGE,FLUXES,
     >              NSPH  ,KSPH  ,CURNAM,CTITRE,
     >              RBASE(ISPH)  )
        IF(HSIGN.EQ.'L_LIBRARY')
     >    CALL LCMSIX(IPLIB,'MACROLIB',ILCMDN)
      ENDIF
      ILEAKS=0
      CALL LCMGET(IPFLUX,'STATE-VECTOR',ISTATE)
      CALL LCMLEN(IPFLUX,'K-EFFECTIVE',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. 1) THEN
        CALL LCMGET(IPFLUX,'K-EFFECTIVE',EIGENK)
      ELSE
        EIGENK=1.0
      ENDIF
      CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMUP)
      CALL XDRSET(B2,4,0.0)
      IF(LEAKSW) ILEAKS=1
      IF(ISTATE(1) .GT. 1.AND.
     >   ISTATE(1) .LT. 6 ) THEN
        CALL LCMGET(IPFLUX,'B2  B1HOM',B2(4))
        ILEAKS=2
        IF(ISTATE(2) .GE. 5) THEN
          ILEAKS=3
          CALL LCMGET(IPFLUX,'B2  HETE',B2)
        ENDIF
      ENDIF
      NBISO=0
C----
C  COMPUTE REACTION RATES FOR THE EDITION MACROLIB
C----
      CALL SETARA(RBASE,4*NREGIO*NGROUP,IFLINT)
      CALL SETARA(RBASE,NMERGE*NGROUP,IANVEL)
      CALL SETARA(RBASE,NGCOND,IDISFC)
      CALL SETARA(IBASE,NMERGE,MATMC)
      CALL SETARA(IBASE,2*NEDMAC,INAMEA)
      CALL SETARA(RBASE,NREGIO*MAX(NIFISS,1),IFFUEL)
      CALL SETARA(RBASE,NREGIO*MAX(NIFISS,1),IFFNFT)
      CALL SETARA(IBASE,NREGIO,IFUELR)
      CALL SETARA(RBASE,NREGIO,IFACT)
      CALL SETARA(IBASE,2*MAX(NIFISS,1),INFI)
      CALL SETARA(IBASE,NBMIX*MAX(NIFISS,1),IMFI)
      CALL SETARA(IBASE,NMERGE*MAX(NIFISS,1),IMFF)
      TIMEF(1)=0.0
      TIMEF(2)=0.0
      TIMEF(3)=0.0
      IF(HSIGN .EQ. 'L_LIBRARY') THEN
        CALL LCMSIX(IPLIB,'MACROLIB',ILCMUP)
        CALL LCMLEN(IPLIB,'TIMESTAMP',ILCMLN,ILCMTY)
        IF(ILCMLN .GE. 1 .AND .ILCMLN .LE. 3) THEN
          CALL LCMGET(IPLIB,'TIMESTAMP',TIMEF)
        ENDIF
      ENDIF
C----
C  99-02-19
C  PASS TO EDIDTX DOUBLE PRECISION VECTOR "IDIRC" FOR DIRECTIONAL
C  ANISOTROPIC SCATTERING CORRECTION
C----
      CALL EDIDTX(IPEDIT,IPFLUX,IPLIB ,IPRINT,NGROUP,NGCOND,
     >            NBMIX ,NREGIO,NMERGE,NL    ,NIFISS,NEDMAC,
     >            NTAUXT,ILEAKS,NWGTH ,ILUPS ,MATCOD,VOLUME,
     >            KEYFLX,IGCOND,IMERGE,FLUXES,EIGENK,NTENER,
     >            ENERGY,ENERV ,NSAVES,CURNAM,B2    ,NBMICR,
     >            HVECT ,NCOMB ,TIMEF ,ITRANC,
     >            RBASE(ISPH)  ,RBASE(IVOLME),RBASE(ITAUXT),
     >            RBASE(IFLINT),RBASE(ISCATD),RBASE(IXSTRD),
     >            RBASE(IDISFC),IBASE(INAMEA),RBASE(IFFUEL),
     >            IBASE(IFUELR),RBASE(IFACT) ,IBASE(MATMC) ,
     >            IBASE(INFI)  ,IBASE(IMFI)  ,IBASE(IMFF)  ,
     >            RBASE(IANVEL),RBASE(IDIRC) ,RBASE(IFFNFT),
     >            RBASE(IEFIS) )
      IF(HSIGN .EQ. 'L_LIBRARY')
     >  CALL LCMSIX(IPLIB,'MACROLIB',ILCMDN)
      CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMDN)
      CALL RLSARA(IBASE(IMFF))
      CALL RLSARA(IBASE(IMFI))
      CALL RLSARA(IBASE(INFI))
      CALL RLSARA(RBASE(IFACT))
      CALL RLSARA(IBASE(IFUELR))
      CALL RLSARA(RBASE(IFFNFT))
      CALL RLSARA(RBASE(IFFUEL))
      CALL RLSARA(IBASE(INAMEA))
      CALL RLSARA(IBASE(MATMC))
      CALL RLSARA(RBASE(IDISFC))
C----
C  EVALUATE H-FACTOR IF LIBRARY EXISTS
C----
      NGFAST=0
      NGEPTH=0 
      NDEPL=0
      IF(HSIGN .EQ. 'L_LIBRARY') THEN
        CALL LCMGET(IPLIB,'STATE-VECTOR',ISTATE)
        NBISO=ISTATE(2)
        NGFAST=ISTATE(9)
        NGEPTH= ISTATE(10)
        NDEPL=ISTATE(11)
        NED=ISTATE(13)
        CALL SETARA(RBASE,NBISO,IDEN)
        CALL SETARA(RBASE,NBISO,ITMP)
        CALL SETARA(IBASE,NBISO,IMIX)
        CALL SETARA(IBASE,3*NBISO,ISONRF)
        CALL SETARA(RBASE,NBISO,ISOAWR)
        CALL SETARA(IBASE,2*NED,IJCEDM)
        CALL LCMGET(IPLIB,'ISOTOPERNAME',IBASE(ISONRF))
        CALL LCMGET(IPLIB,'ISOTOPESMIX',IBASE(IMIX))
        CALL LCMGET(IPLIB,'ISOTOPESAWR ',RBASE(ISOAWR))
        CALL LCMGET(IPLIB,'ISOTOPESDENS',RBASE(IDEN))
        CALL LCMGET(IPLIB,'ISOTOPESTEMP',RBASE(ITMP))
        CALL LCMGET(IPLIB,'HVECT',IBASE(IJCEDM))
        IDEB=IJCEDM
        DO 100 IED=1,NED
          WRITE(HVECT(IED),'(A4,A2)') IBASE(IDEB),IBASE(IDEB+1)
          IDEB=IDEB+2
  100   CONTINUE
      ENDIF
      CALL SETARA(RBASE,NBISO,IEJ)
      CALL XDRSET(RBASE(IEJ),NBISO,0.0)
      IF(NSAVES .EQ. 2) THEN
        CALL LCMLEN(IPLIB,'DEPL-CHAIN',ILCMLN,ILCMTY)
        IF(ILCMLN .EQ. -1) THEN
          CALL LCMSIX(IPLIB,'DEPL-CHAIN',ILCMUP)
          CALL LCMGET(IPLIB,'STATE-VECTOR',ISTATE)
          NDEPL=ISTATE(1)
          NDFI=ISTATE(2)
          NDFP=ISTATE(3)
          NHEAVY=ISTATE(4)
          NLIGHT=ISTATE(5)
          NOTHER=ISTATE(6)
          NBXR=ISTATE(7)
          CALL SETARA(IBASE,2*NDEPL,INADPL)
          CALL SETARA(IBASE,MAXR*NDEPL,IDEPR)
          CALL SETARA(RBASE,MAXR*NDEPL,JDEPR)
          CALL LCMGET(IPLIB,'ISOTOPESUSED',IBASE(INADPL))
          CALL LCMGET(IPLIB,'DEPLETE-REAC',IBASE(IDEPR))
          CALL LCMGET(IPLIB,'DEPLETE-RATE',RBASE(JDEPR))
          IF(NSAVES .EQ. 2 .AND. NBMICR .NE. 0) THEN
            CALL SETARA(IBASE,NDEPL,IIZAE)
            CALL SETARA(IBASE,NBXR*NDEPL,IKPAR)
            CALL SETARA(RBASE,NBXR*NDEPL,IBPAR)
            CALL SETARA(RBASE,NDFI*NDFP,IYIELD)
            CALL LCMGET(IPLIB,'CHARGEWEIGHT',IBASE(IIZAE))
            CALL LCMGET(IPLIB,'PRODUCE-REAC',IBASE(IKPAR))
            CALL LCMGET(IPLIB,'PRODUCE-RATE',RBASE(IBPAR))
            CALL LCMGET(IPLIB,'FISSIONYIELD',RBASE(IYIELD))
C----
C  SAVE DEPLETION CHAIN
C----
            CALL LCMSIX(IPEDIT,CURNAM,ILCMUP)
            CALL LCMSIX(IPEDIT,'DEPL-CHAIN',ILCMUP)
            CALL LCMPUT(IPEDIT,'STATE-VECTOR',NSTATE,1,ISTATE)
            CALL LCMPUT(IPEDIT,'ISOTOPESUSED',
     >                  2*NDEPL,3,IBASE(INADPL))
            CALL LCMPUT(IPEDIT,'DEPLETE-REAC',
     >                  MAXR*NDEPL,1,RBASE(IDEPR))
            CALL LCMPUT(IPEDIT,'DEPLETE-RATE',
     >                  MAXR*NDEPL,2,IBASE(JDEPR))
            CALL LCMPUT(IPEDIT,'CHARGEWEIGHT',
     >                  NDEPL,1,IBASE(IIZAE))
            CALL LCMPUT(IPEDIT,'PRODUCE-REAC',
     >                  NBXR*NDEPL,1,IBASE(IKPAR))
            CALL LCMPUT(IPEDIT,'PRODUCE-RATE',
     >                  NBXR*NDEPL,2,RBASE(IBPAR))
            CALL LCMPUT(IPEDIT,'FISSIONYIELD',
     >                  NDFI*NDFP,2,RBASE(IYIELD))
            CALL LCMSIX(IPEDIT,'DEPL-CHAIN',ILCMDN)
            CALL LCMSIX(IPEDIT,CURNAM,ILCMDN)
            CALL RLSARA(RBASE(IYIELD))
            CALL RLSARA(RBASE(IBPAR))
            CALL RLSARA(IBASE(IKPAR))
            CALL RLSARA(IBASE(IIZAE))
          ENDIF
          CALL LCMSIX(IPLIB,'DEPL-CHAIN',ILCMDN)
          CALL SETARA(RBASE,NGROUP,ISIGF)
          CALL SETARA(RBASE,NMERGE,IHFACT)
          CALL SETARA(RBASE,2*NGCOND*NMERGE,IHFSO)
          CALL SETARA(RBASE,2*NMERGE,IDFISS)
          CALL SETARA(RBASE,2*NMERGE,IDPROD)
          CALL EDIHFC(IPEDIT,IPLIB ,NGROUP,NGCOND,NREGIO,NMERGE,
     >                NBISO ,MAXR  ,NDEPL ,MATCOD,ISONAM,CURNAM,
     >                IGCOND,IMERGE,
     >                IBASE(INADPL),IBASE(ISONRF),IBASE(IMIX)  ,
     >                RBASE(IFLINT),RBASE(ITAUXT),RBASE(IDEN)  ,
     >                IBASE(IDEPR) ,RBASE(JDEPR) ,RBASE(ISIGF) ,
     >                RBASE(IHFACT),RBASE(IHFSO) ,RBASE(IEJ)   ,
     >                RBASE(IDFISS),RBASE(IDPROD))
          CALL RLSARA(RBASE(IDPROD))
          CALL RLSARA(RBASE(IDFISS))
          CALL RLSARA(RBASE(IHFSO))
          CALL RLSARA(RBASE(IHFACT))
          CALL RLSARA(RBASE(ISIGF))
          CALL RLSARA(RBASE(JDEPR))
          CALL RLSARA(IBASE(IDEPR))
          CALL RLSARA(IBASE(INADPL))
        ENDIF
      ENDIF
C----
C  COMPUTE MICROSCOPIC CROSS SECTIONS
C----
      IMSTEP(1)=0
      IF(NBMICR .NE. 0 .OR. NBISO .NE. 0) THEN
        IMSTEP(1)=NSAVES
        NDIALC=NBISO
      ELSE
        NDIALC=1
      ENDIF
C----
C  ALLOCATE GLOBAL TEMPORARY WORK VECTOR
C----
      CALL SETARA(IBASE,3*NMERGE*NDIALC,INNAM)
      CALL SETARA(IBASE,2*NDIALC,INDISO)
      CALL SETARA(IBASE,(NMERGE+1)*NDIALC,INDMIC)
      CALL SETARA(RBASE,2*NMERGE*NDIALC,IDNUM)
      CALL SETARA(RBASE,2*NMERGE,IDNUMX)
      CALL SETARA(RBASE,2*NMERGE*NDIALC,IDTMP)
      CALL SETARA(IBASE,NREGIO*NDIALC,ISOCOD)
      CALL SETARA(RBASE,2*NMERGE*NDIALC,IDVOL)
      CALL SETARA(IBASE,3*NMERGE*NDIALC,INNRF)
      CALL SETARA(IBASE,NMERGE*NDIALC,INMIX)
      CALL SETARA(RBASE,NMERGE*NDIALC,INAWR)
      CALL SETARA(RBASE,NMERGE*NDIALC,INDEN)
      CALL SETARA(RBASE,NMERGE*NDIALC,INTMP)
      CALL SETARA(RBASE,NMERGE*NDIALC,INVOL)
      CALL SETARA(RBASE,NMERGE*NDIALC,ISNEJ)
      CALL SETARA(RBASE,2*NGROUP*4,IDFLX)
      CALL SETARA(RBASE,2*NGCOND*3,IDFLG)
      IMSTEP(2)=0
      IF(NACTI .GT. 0) THEN
        IMSTEP(2)=4
      ENDIF
      NBIXS=IXEDI
      DO 110 ISTEP=1,NMSTEP
        NSSTP=IMSTEP(ISTEP)
        IF(NSSTP .GT. 0) THEN
          IF(NSSTP .GE. 2) THEN
            CALL LCMSIX(IPEDIT,CURNAM,ILCMUP)
            IF(NSSTP .EQ. 4) THEN
              CALL LCMSIX(IPEDIT,'ACTIVATION',ILCMUP)
            ENDIF
          ENDIF
C----
C  CLASSIFY ISOTOPES
C----
          CALL EDIISO(IPEDIT,NSSTP ,NACTI ,NREGIO,NMERGE,NBISO ,
     >                NBMIX ,NBMICR,NBNMIC,NBNISO,ISOCAR,ISONAM,
     >                MATCOD,IMERGE,VOLUME,IACTI,
     >                IBASE(ISONRF),IBASE(IMIX)  ,RBASE(ISOAWR),
     >                RBASE(IDEN)  ,RBASE(ITMP)  ,RBASE(IEJ)   ,
     >                RBASE(IVOLME),IBASE(INDISO),IBASE(INDMIC),
     >                IBASE(INNAM) ,IBASE(INNRF) ,IBASE(INMIX) ,
     >                RBASE(INAWR) ,RBASE(INDEN) ,RBASE(INTMP) ,
     >                RBASE(INVOL) ,RBASE(ISNEJ) ,RBASE(IDNUM) ,
     >                RBASE(IDTMP) ,RBASE(IDVOL),RBASE(IDNUMX) ,
     >                IBASE(ISOCOD))
C----
C  EDIT MICROSCOPIC CROSS SECTIONS
C----
          CALL EDIMIC(IPEDIT,IPLIB ,IPRINT,NGROUP,NGCOND,NREGIO,
     >                NMERGE,NL    ,NBISO ,NBMIX ,NED   ,ILEAKS,
     >                ILUPS ,NSSTP ,NTAUXT,B2    ,TIMEF ,NBNMIC,
     >                HVECT ,ISOCAR,ISONAM,IGCOND,IMERGE,
     >                RBASE(IFLINT),RBASE(IDEN)  ,RBASE(IVOLME),
     >                RBASE(ITAUXT),IBASE(INDISO),IBASE(INDMIC),
     >                RBASE(IDNUM) ,RBASE(IDFLX) ,RBASE(IDFLG) ,
     >                RBASE(IDNUMX),IBASE(ISOCOD),RBASE(IXSTRD),
     >                RBASE(ISPH))
          IF(ISOTXS(ISTEP) .EQ. 1) THEN
            IF(IPRINT .GE. 1) THEN
              WRITE(IOUT,6000) NAMSBR
            ENDIF
            NPROC=NDPROC+NL
            CALL SETARA(IBASE,NPROC,ITYPRO)
            CALL SETARA(IBASE,NBNISO,LOCISO)
            CALL SETARA(IBASE,NGCOND,IIJJ)
            CALL SETARA(IBASE,NGCOND,INJJ)
            DO 120 IMRG=1,NMERGE
              NBIXS=NBIXS+1
              WRITE(NISEXT,'(I6)') NBIXS
              DO 121 ICAR=1,6
                IF(NISEXT(ICAR:ICAR) .EQ. ' ' .OR.
     >             NISEXT(ICAR:ICAR) .EQ. '*') THEN
                   NISEXT(ICAR:ICAR)='0'
                ENDIF
 121          CONTINUE
              NISOTX='ISOTXS'//NISEXT
C----
C  GENERATE ONE ISOTXS FILE FOR EACH MERGED REGION IN EACH
C  ACTIVATION MATERIAL AND FLIB
C----
             IF(NSSTP .EQ. 4) THEN
               WRITE(CTITLE,9000) NAMSBR,CURNAM,
     >                            'ACTIVATION  ','MIX',IMRG,NISOTX
               IF(IPRINT .GE. 1) WRITE(IOUT,6001) IMRG,NISOTX
             ELSE
               WRITE(CTITLE,9000) NAMSBR,CURNAM,
     >                            'FLIB OR MIC ','MIX',IMRG,NISOTX
               IF(IPRINT .GE. 1) WRITE(IOUT,6002) IMRG,NISOTX
             ENDIF
             IWGOXS=KDROPN(NISOTX,0,ITGOXS,0,0)
             CALL EDITXS(IPEDIT,IWGOXS,IPRINT,NGCOND,NMERGE,NL    ,
     >                   NBNISO,CTITLE,IMRG  ,NPROC ,ENERGY,
     >                   IBASE(INNAM) ,IBASE(INNRF) ,IBASE(INMIX) ,
     >                   RBASE(INAWR) ,RBASE(INDEN) ,RBASE(INTMP) ,
     >                   RBASE(INVOL) ,RBASE(ISNEJ) ,RBASE(IANVEL),
     >                   IBASE(ITYPRO),IBASE(LOCISO),IBASE(IIJJ)  ,
     >                   IBASE(INJJ)  )
              IRETRN=KDRCLS(IWGOXS,1)
 120        CONTINUE
            CALL RLSARA(IBASE(INJJ))
            CALL RLSARA(IBASE(IIJJ))
            CALL RLSARA(IBASE(LOCISO))
            CALL RLSARA(IBASE(ITYPRO))
          ENDIF
          IF(NSSTP .GE. 2) THEN
            CALL XDRSET(ISTATE,NSTATE,0)
            ISTATE(1)=NMERGE
            ISTATE(2)=NBNISO
            ISTATE(3)=NGCOND
            ISTATE(4)=NL
            ISTATE(5)=2
            ISTATE(6)=0
            ISTATE(7)=1
            ISTATE(8)=1
            ISTATE(9)=NGFAST
            ISTATE(10)=NGEPTH
            ISTATE(11)=NDEPL
            ISTATE(12)=NCOMB
            ISTATE(13)=NED
            ISTATE(14)=NMERGE
            ISTATE(15)=0
            ISTATE(16)=NBISO
            ISTATE(17)=NDPROC
            CALL LCMPUT(IPEDIT,'STATE-VECTOR',NSTATE,1,ISTATE)
            CALL LCMPUT(IPEDIT,'HVECT',2*NED,3,IBASE(IJCEDM))
            CALL LCMPUT(IPEDIT,'SIGNATURE',3,3,KCHAR)
            IF(NTENER .GT. 0) THEN
              CALL LCMPUT(IPEDIT,'ENERGY',NGCOND+1,2,ENERGY)
              CALL LCMPUT(IPEDIT,'DELTAU',NGCOND,2,ENERGY(NGCOND+2))
            ENDIF
            IF(NSSTP .EQ. 4) THEN
              CALL LCMSIX(IPEDIT,'ACTIVATION',ILCMDN)
            ENDIF
            CALL LCMSIX(IPEDIT,CURNAM,ILCMDN)
          ENDIF
        ENDIF
 110  CONTINUE
C----
C  RELEASE GLOBAL TEMPORARY WORK VECTOR
C----
      CALL RLSARA(RBASE(IDFLG))
      CALL RLSARA(RBASE(IDFLX))
      CALL RLSARA(RBASE(ISNEJ))
      CALL RLSARA(RBASE(INVOL))
      CALL RLSARA(RBASE(INTMP))
      CALL RLSARA(RBASE(INDEN))
      CALL RLSARA(RBASE(INAWR))
      CALL RLSARA(IBASE(INMIX))
      CALL RLSARA(IBASE(INNRF))
      CALL RLSARA(RBASE(IDVOL))
      CALL RLSARA(IBASE(ISOCOD))
      CALL RLSARA(RBASE(IDTMP))
      CALL RLSARA(RBASE(IDNUMX))
      CALL RLSARA(RBASE(IDNUM))
      CALL RLSARA(IBASE(INDMIC))
      CALL RLSARA(IBASE(INDISO))
      CALL RLSARA(IBASE(INNAM))
      CALL RLSARA(RBASE(IANVEL))
      CALL RLSARA(RBASE(IFLINT))
      CALL RLSARA(RBASE(IEJ))
      IF(HSIGN .EQ. 'L_LIBRARY') THEN
        CALL RLSARA(IBASE(IJCEDM))
        CALL RLSARA(RBASE(ISOAWR))
        CALL RLSARA(IBASE(ISONRF))
        CALL RLSARA(IBASE(IMIX))
        CALL RLSARA(RBASE(ITMP))
        CALL RLSARA(RBASE(IDEN))
      ENDIF
      CALL RLSARA(RBASE(IXSTRD))
C----
C  STATISTICS AND DELTA SIGMAS
C----
      IF(NSTATS .NE. 0) THEN
        MXVAL=2*MAX(NMERGE,NGROUP)
        MXERR=NMERGE*MAX(NGCOND,NIFISS)
        CALL SETARA(RBASE,NMERGE,IOLDFL)
        CALL SETARA(RBASE,MXVAL,IOLDVA)
        CALL SETARA(RBASE,MXERR,IVALER)
        CALL SETARA(IBASE,NMERGE,INGSCT)
        CALL SETARA(IBASE,NMERGE,IFGSCT)
        CALL SETARA(IBASE,NMERGE,IPOSCT)
        CALL EDIDST(IPEDIT,IPRINT,NSTATS,NGCOND,NMERGE,NL    ,
     >              NIFISS,NEDMAC,NTAUXT,NTENER,ENERGY,OLDNAM,
     >              MXVAL ,MXERR ,
     >              RBASE(IVOLME),RBASE(ITAUXT),RBASE(ISCATD),
     >              RBASE(IOLDFL),RBASE(IOLDVA),RBASE(IVALER),
     >              IBASE(INGSCT),IBASE(IFGSCT),IBASE(IPOSCT))
        CALL RLSARA(IBASE(IPOSCT))
        CALL RLSARA(IBASE(IFGSCT))
        CALL RLSARA(IBASE(INGSCT))
        CALL RLSARA(RBASE(IVALER))
        CALL RLSARA(RBASE(IOLDVA))
        CALL RLSARA(RBASE(IOLDFL))
      ENDIF
C----
C  FOUR FACTORS
C----
      IF(IFFAC .NE. 0) THEN
        CALL SETARA(IBASE,NMERGE,ITYPER)
        CALL SETARA(RBASE,8*(NGCOND+1),IDRATE)
        CALL SETARA(RBASE,4*(NGCOND+1),IDLEAK)
        CALL EDIBAL(IPEDIT,IPRINT,NGCOND,NMERGE,NTAUXT,IFFAC ,
     >              EIGENK,B2    ,ILEAKS,
     >              RBASE(ITAUXT),RBASE(ISCATD),IBASE(ITYPER),
     >              RBASE(IDRATE),RBASE(IDLEAK))
        CALL RLSARA(RBASE(IDLEAK))
        CALL RLSARA(RBASE(IDRATE))
        CALL RLSARA(IBASE(ITYPER))
      ENDIF
      CALL RLSARA(RBASE(ISPH))
      CALL RLSARA(RBASE(ISCATD))
      CALL RLSARA(RBASE(IVOLME))
C----
C  99-02-19
C  RELEASE DOUBLE PRECISION VECTOR "IDIRC" FOR DIRECTIONAL
C  ANISOTROPIC SCATTERING CORRECTION
C----
      CALL RLSARA(RBASE(IDIRC))
      CALL RLSARA(RBASE(IEFIS))
      CALL RLSARA(RBASE(ITAUXT))
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(1X,A6,': GENERATING ISOTXS FILE ')
 6001 FORMAT(10X,' FOR ACTIVATION MIXTURE = ',I6,
     >           ' INFORMATION STORED ON FILE = ',A12)
 6002 FORMAT(10X,' FOR EDITING MIXTURE    = ',I6,
     >           ' INFORMATION STORED ON FILE = ',A12)
 9000 FORMAT(1X,A6,3X,A12,3X,A12,3X,A4,I6,5X,A12)
      END
