*DECK EDIISO
      SUBROUTINE EDIISO(IPEDIT,NSSTP ,NACTI ,NREGIO,NMERGE,NBISO ,
     >                  NBMIX ,NBMICR,NBNMIC,NBNISO,ISOCAR,ISONAM,
     >                  MATCOD,IMERGE,VOLUME,IACTI ,
     >                  ISONRF,MIXISO,AWRISO,DENISO,TMPISO,EJISO ,
     >                  VOLMER,INDISO,INDMIC,ISNNAM,ISNNRF,MIXISN,
     >                  AWRISN,DENISN,TMPISN,VOLISN,EJISN ,DNUM  ,
     >                  DTMP  ,DVOL  ,DNUMMX,ISOCOD)
*
*-----------------------------------------------------------------------
*
* SELECTION OF ISOTOPES FOR HOMOGENIZATION AND CONDENSATION
* OF MICROSCOPIC OR ACTIVATION CROSS SECTION.
*
*  IPEDIT  : POINTER TO THE EDIT DATA STRUCTURE
*  NSSTP   : HOMOGENIZED X-S SAVE IF NSSTP=2,3,4
*  NACTI   : NUMBER OF ACTIVATION MIXTURE
*  NREGIO  : NUMBER OF VOLUMES.
*  NMERGE  : NUMBER OF MERGED REGIONS.
*  NBISO   : NUMBER OF ISOTOPES.
*  NBMIX   : NUMBER OF MIXTURES.
*  NBMICR  : NUMBER OF MICROSCOPIC SAVED
*  NBNMIC  : NUMBER OF NEW REFERENCE NAME
*  NBNISO  : NUMBER OF NEW ISOTOPES
*  ISOCAR  : NAMES OF SAVED ISOTOPES.        ISOCAR(2,NBISO)
*  ISONAM  : NAMES OF ISOTOPES.              ISONAM(3,NBISO)
*  MATCOD  : MIXTURE INDEX PER VOLUME.       MATCOD(NREGIO)
*  IMERGE  : INDEX OF MERGED REGIONS.        IMERGE(NREGIO)
*  VOLUME  : VOLUMES.                        VOLUME(NREGIO)
*  IACTI   : MIXTURES WITH ACTIVATION EDITS  IACTI(NBMIX)
*  ISONRF  : REFERENCE NAMES OF ISOTOPES.    ISONRF(3,NBISO)
*  MIXISO  : MIXTURE NUMBER FOR ISOTOPE.     MIXISO(NBISO)
*  AWRISO  : AWR FOR ISOTOPE.                AWRISO(NBISO)
*  DENISO  : DENSITY FOR ISOTOPE.            DENISO(NBISO)
*  TMPISO  : TEMPERATURE FOR ISOTOPE.        TMPISO(NBISO)
*  EJISO   : ENERGY FOR ISOTOPES             EJISO(NBISO)
*            M-JOULES FOR 10**24 FISSION
*  VOLMER  : VOLUME OF REGION MERGED.        VOLMER(NMERGE)
*  INDISO  : FLAG TO TREAT OR NOT ISOTOPE.   INDISO(NBISO,2)
*  INDMIC  : FLAG TO GENERATE MICROSCOPIC.   INDMIC(NMERGE+1,NBISO)
*  DNUM    : NUMBER OF NUCLIDE OF ISO IN MIX DNUM(NMERGE,NBISO)
*  DTMP    : TEMPERATURE OF NUCLIDE.         DTEMP(NMERGE,NBISO)
*  DVOL    : VOLUME OF OLD NUCLIDES.         DVOL(NMERGE,NBISO)
*  DNUMMX  : NUMBER OF NUCLIDE IN MIX        DNUMMX(NMERGE)
*  ISOCOD  : NEW ISOTOPE IN OLD REGION.      ISOCOD(NREGIO,NBISO)
*  ISNNAM  : NAMES OF NEW ISOTOPES.          ISNNAM(3,NMERGE*NBISO)
*  ISNNRF  : REFERENCE NAMES OF NEW ISOTOPES ISNNRF(3,NMERGE*NBISO)
*  MIXISN  : MIXTURE NUMBER FOR NEW ISOTOPES MIXISN(NMERGE*NBISO)
*  AWRISN  : AWR FOR NEW ISOTOPES            AWRISN(NMERGE*NBISO)
*  DENISN  : DENSITY FOR NEW ISOTOPES        DENISN(NMERGE*NBISO)
*  TMPISN  : TEMPERATURE FOR NEW ISOTOPES    TMPISN(NMERGE*NBISO)
*  VOLISN  : VOLUME RATIO FOR NEW ISOTOPES   VOLISN(NMERGE*NBISO)
*  EJISN   : ENERGY FOR NEW ISOTOPES         EJISN(NMERGE*NBISO)
*            M-JOULES FOR 10**24 FISSION
*
*-------------------------------------MODIFIED: G. MARLEAU 97/04/02 ----
*
      IMPLICIT         NONE
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='EDIISO')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          IPEDIT,NSSTP,NACTI,NREGIO,NMERGE,NBISO,NBMIX,
     >                 NBMICR,NBNMIC,NBNISO
      INTEGER          ISOCAR(2,NBISO),ISONAM(3,NBISO),
     >                 MATCOD(NREGIO),IMERGE(NREGIO),IACTI(NACTI),
     >                 ISONRF(3,NBISO),MIXISO(NBISO),
     >                 INDISO(NBISO,2),INDMIC(NMERGE+1,NBISO),
     >                 ISOCOD(NREGIO,NBISO),ISNNAM(3,NMERGE*NBISO),
     >                 ISNNRF(3,NMERGE*NBISO),MIXISN(NMERGE*NBISO)
      REAL             VOLUME(NREGIO),AWRISO(NBISO),DENISO(NBISO),
     >                 TMPISO(NBISO),EJISO(NBISO),
     >                 AWRISN(NMERGE*NBISO),DENISN(NMERGE*NBISO),
     >                 TMPISN(NMERGE*NBISO),VOLISN(NMERGE*NBISO),
     >                 EJISN(NMERGE*NBISO)
      DOUBLE PRECISION VOLMER(NMERGE),DNUM(NMERGE,NBISO),
     >                 DTMP(NMERGE,NBISO),DVOL(NMERGE,NBISO),
     >                 DNUMMX(NMERGE)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER      IBASE(1)
      LOGICAL      LBASE(1)
      REAL         RBASE
      COMMON       RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1),LBASE(1))
      INTEGER      IHLIB
C----
C  LOCAL PARAMETERS
C----
      CHARACTER        TEXT4*4,TEXT8*8
      INTEGER          ITEXT4,IRE,ISO,IMIXR,IMICR,JSO,IREGIO,
     >                 ISOC,IMR,ISOOLD,MIX,MIXREG,JNDMIC
C----
C  ALLOCATE MEMORY FOR DUMMY LIBRARY INFORMATION VECTOR
C----
      CALL SETARA(IBASE,2*NMERGE*NBISO,IHLIB)
C----
C  FIND LIST OF ACTIVATION ISOTOPES ISOCAR (NSSTP =4)
C----
      IF(NSSTP .EQ. 4) THEN
        NBNMIC=0
        DO 100 IRE=1,NACTI
          IMIXR=IACTI(IRE)
          DO 101 ISO=1,NBISO
            IF(MIXISO(ISO) .EQ. IMIXR) THEN
              DO 102 IMICR=1,NBNMIC
                IF(ISOCAR(1,IMICR) .EQ. ISONAM(1,ISO) .AND.
     >             ISOCAR(2,IMICR) .EQ. ISONAM(2,ISO)) GO TO 105
 102          CONTINUE
              NBNMIC=NBNMIC+1
              ISOCAR(1,NBNMIC)=ISONAM(1,ISO)
              ISOCAR(2,NBNMIC)=ISONAM(2,ISO)
              MIXISN(NBNMIC)=ISO
 105          CONTINUE
            ENDIF
 101      CONTINUE
 100    CONTINUE
      ELSE
C----
C  FIND LIST OF ACTIVATION ISOTOPES IF NBMICR=-1 OR NBMICR=1
C  TAKE ALL ISOTOPES OTHERWISE TAKE ONLY SELECTED ISOTOPES
C----
        IF(ABS(NBMICR) .EQ. 1) THEN
          NBNMIC=0
          DO 106 ISO=1,NBISO
            DO 107 JSO=1,NBNMIC
              IF(ISOCAR(1,JSO) .EQ. ISONAM(1,ISO) .AND.
     >           ISOCAR(2,JSO) .EQ. ISONAM(2,ISO)) GO TO 109
 107        CONTINUE
            NBNMIC=NBNMIC+1
            ISOCAR(1,NBNMIC)=ISONAM(1,ISO)
            ISOCAR(2,NBNMIC)=ISONAM(2,ISO)
 109        CONTINUE
 106      CONTINUE
        ELSE
          NBNMIC=ABS(NBMICR)-1
        ENDIF
      ENDIF
C----
C  SCAN FOR INDEPENDANT INITIAL ISOTOPE NAMES
C----
      CALL XDRSET(INDISO,NBISO*2,0)
      DO 110 ISO=1,NBISO
        IF(INDISO(ISO,1).EQ.0) THEN
          INDISO(ISO,1)=ISO
          DO 111 IMICR=1,NBNMIC
            IF(ISOCAR(1,IMICR) .EQ. ISONAM(1,ISO) .AND.
     >         ISOCAR(2,IMICR) .EQ. ISONAM(2,ISO)) THEN
              INDISO(ISO,2)=IMICR
              GO TO 115
            ENDIF
 111      CONTINUE
 115      CONTINUE
          DO 116 JSO=ISO+1,NBISO
            IF(INDISO(JSO,1) .EQ. 0) THEN
              IF(ISONAM(1,JSO) .EQ. ISONAM(1,ISO) .AND.
     >           ISONAM(2,JSO) .EQ. ISONAM(2,ISO) .AND.
     >           ISONAM(3,JSO) .EQ. ISONAM(3,ISO)) THEN
                INDISO(JSO,1)=-INDISO(ISO,1)
                INDISO(JSO,2)=INDISO(ISO,2)
              ENDIF
            ENDIF
 116      CONTINUE
        ENDIF
 110  CONTINUE
C----
C  FOR EACH ISOTOPE TO SAVE FIND WHERE THIS ISOTOPE IS LOCATED
C  AND TO WHICH ORIGINAL REGION AND ISOTOPE IT WAS ASSOCIATED
C----
      CALL XDRDBL(DNUM,NBNMIC*NMERGE,0.0D0)
      CALL XDRDBL(DVOL,NBNMIC*NMERGE,0.0D0)
      CALL XDRDBL(DTMP,NBNMIC*NMERGE,0.0D0)
      CALL XDRSET(INDMIC,(NMERGE+1)*NBNMIC,0)
      CALL XDRSET(ISOCOD,NREGIO*NBISO,0)
      DO 130 IREGIO=1,NREGIO
        MIXREG=MATCOD(IREGIO)
        IMR=IMERGE(IREGIO)
        IF(IMR .GT. 0) THEN
          DO 131 ISO=1,NBISO
            MIX=MIXISO(ISO)
            JNDMIC=INDISO(ISO,2)
            IF(JNDMIC .NE. 0) THEN
              IF(NSSTP .EQ. 4) THEN
                IF(MIX .EQ. MIXREG) THEN
C----
C  FOR ACTI ISOTOPES ALREADY IN A REGION SELECT ISOTOPE IN THE
C  CORRESPONDING MIXTURE
C----
                  ISOCOD(IREGIO,ISO)=JNDMIC
                  INDMIC(IMR,JNDMIC)=ISO
                  INDMIC(NMERGE+1,JNDMIC)=1
                ELSE
C----
C  FOR ACTI ISOTOPES NOT IN A REGION TAG THIS REGION FOR FURTHER
C  PROCESSING AS -1
C----
                  ISOCOD(IREGIO,ISO)=-JNDMIC
                  INDMIC(IMR,JNDMIC)=ISO
                  INDMIC(NMERGE+1,JNDMIC)=1
                ENDIF
              ELSE
                IF(MIX .EQ. MIXREG) THEN
C----
C  FOR MICR ISOTOPES ALREADY IN A REGION SELECT ISOTOPE IN THE
C  CORRESPONDING MIXTURE
C----
                  ISOCOD(IREGIO,ISO)=JNDMIC
                  INDMIC(IMR,JNDMIC)=ISO
                  INDMIC(NMERGE+1,JNDMIC)=1
                  DNUM(IMR,JNDMIC)=DNUM(IMR,JNDMIC)+
     >                             DBLE(DENISO(ISO)*VOLUME(IREGIO))
                  DTMP(IMR,JNDMIC)=DTMP(IMR,JNDMIC)+
     >               DBLE(TMPISO(ISO)*VOLUME(IREGIO)*
     >               MAX(DENISO(ISO),1.0E-30))
                  DVOL(IMR,JNDMIC)=DVOL(IMR,JNDMIC)+
     >                             DBLE(VOLUME(IREGIO))
                ENDIF
              ENDIF
            ENDIF
 131      CONTINUE
        ENDIF
 130  CONTINUE
      IF(NSSTP .EQ. 4) THEN
C----
C  FOR ACTI ISOTOPES IF MORE THAN 1 ISOTOPE ASSOCIATED
C  WITH A GIVEN REGION SELECT THE REFERENCE ISOTOPE FOR THIS
C  REGION OR THE FIRST ISOTOPE ENCONTERED
C----
        DO 150 IREGIO=1,NREGIO
          DO 151 ISO=1,NBISO
            IF(ISOCOD(IREGIO,ISO) .LT. 0) THEN
              ISOC=-ISOCOD(IREGIO,ISO)
              DO 152 JSO=1,NBISO
                IF(ISOCOD(IREGIO,JSO) .EQ. ISOC) THEN
                  ISOCOD(IREGIO,ISO)=0
                  GO TO 155
                ENDIF
 152          CONTINUE
              IF(ISO .EQ. MIXISN(ISOC)) THEN
                ISOCOD(IREGIO,ISO)=ISOC
              ELSE
                ISOCOD(IREGIO,ISO)=0
              ENDIF
            ENDIF
 155        CONTINUE
 151      CONTINUE
 150    CONTINUE
      ENDIF
C----
C  FIND IF ISOTOPE IS PRESENT IN MERGE REGION AND TEST FOR DENSITY
C  IF DENSITY > 0.0 COMPUTE NEW AVERAGE DENSITY
C  IF DENSITY = 0.0 STORE -VOLMER IN DENSITY
C----
      NBNISO=0
      DO 140 IMICR=1,NBNMIC
C----
C  FIND POINTER TO ISOOLD FOR AWR AND ISONRF/
C  ASSUMING A GIVEN ISOTOPE NAME CAN COME FROM ONLY ONE LIBRARY
C  TYPE
C----
        IF(INDMIC(NMERGE+1,IMICR) .NE. 0) THEN
          DO 141 IMR=1,NMERGE
            WRITE(TEXT4,'(I4)') IMR
            READ(TEXT4,'(A4)') ITEXT4
            IF(INDMIC(IMR,IMICR) .NE. 0) THEN
              NBNISO=NBNISO+1
              ISOOLD=INDMIC(IMR,IMICR)
              ISNNAM(1,NBNISO)=ISOCAR(1,IMICR)
              ISNNAM(2,NBNISO)=ISOCAR(2,IMICR)
              ISNNAM(3,NBNISO)=ITEXT4
              ISNNRF(1,NBNISO)=ISONRF(1,ISOOLD)
              ISNNRF(2,NBNISO)=ISONRF(2,ISOOLD)
              ISNNRF(3,NBNISO)=ISONRF(3,ISOOLD)
              MIXISN(NBNISO)=IMR
              AWRISN(NBNISO)=AWRISO(ISOOLD)
              IF(DNUM(IMR,IMICR) .GT. 0.0D0) THEN
                TMPISN(NBNISO)=DTMP(IMR,IMICR)/DNUM(IMR,IMICR)
                DENISN(NBNISO)=(DNUM(IMR,IMICR)/VOLMER(IMR))
                DNUM(IMR,IMICR)=DENISN(NBNISO)
                VOLISN(NBNISO)=(DVOL(IMR,IMICR)/VOLMER(IMR))
                DVOL(IMR,IMICR)=VOLISN(NBNISO)
              ELSE
C----
C  IF TOTAL DENSITY IS NEGATIVE MEANING INITIAL DENSITY OF
C  EACH ISOTOPE TO BE IDENTICALLY 0.0 ASSUME UNIFORM INITIAL
C  DENSITY OF -1.0 FOR A TOTAL DENSITY OF -VOLMER
C----
                DENISN(NBNISO)=0.0
                IF(DVOL(IMR,IMICR) .EQ. 0.0D0) THEN
                  TMPISN(NBNISO)=0.0
                  DNUM(IMR,IMICR)=-1.0D0
                  VOLISN(NBNISO)=0.0
                  DVOL(IMR,IMICR)=-1.0D0
                ELSE
                  TMPISN(NBNISO)=1.0E30*DTMP(IMR,IMICR)/DVOL(IMR,IMICR)
                  VOLISN(NBNISO)=(DVOL(IMR,IMICR)/VOLMER(IMR))
                  DVOL(IMR,IMICR)=-VOLISN(NBNISO)
                  DNUM(IMR,IMICR)=DVOL(IMR,IMICR)
                ENDIF
              ENDIF
              EJISN(NBNISO)=EJISO(ISOOLD)
            ENDIF
 141      CONTINUE
        ENDIF
 140  CONTINUE
      DO 160 IMR=1,NMERGE
        DNUMMX(IMR)=0.0D0
        DO 161 IMICR=1,NBNMIC
          DNUMMX(IMR)=DNUMMX(IMR)+DNUM(IMR,IMICR)
 161    CONTINUE
 160  CONTINUE
      IF(NSSTP .EQ. 2 .OR. NSSTP .EQ. 4) THEN
        IF(NBNISO .GT. 0) THEN
          CALL LCMPUT(IPEDIT,'ISOTOPESUSED',3*NBNISO,3,ISNNAM)
          CALL LCMPUT(IPEDIT,'ISOTOPERNAME',3*NBNISO,3,ISNNRF)
          CALL LCMPUT(IPEDIT,'ISOTOPESMIX ',NBNISO,1,MIXISN)
          CALL LCMPUT(IPEDIT,'ISOTOPESAWR ',NBNISO,2,AWRISN)
          CALL LCMPUT(IPEDIT,'ISOTOPESDENS',NBNISO,2,DENISN)
          CALL LCMPUT(IPEDIT,'ISOTOPESTEMP',NBNISO,2,TMPISN)
          CALL LCMPUT(IPEDIT,'ISOTOPESVOLR',NBNISO,2,VOLISN)
          CALL LCMPUT(IPEDIT,'ISOTOPES-EMJ',NBNISO,2,EJISN)
          TEXT8='DRAGON '
          JSO=IHLIB 
          DO 200 ISO=1,NBNISO
            READ(TEXT8,'(2A4)') IBASE(JSO),IBASE(JSO+1)
            JSO=JSO+2   
 200      CONTINUE       
          CALL LCMPUT(IPEDIT,'ILIBRARYTYPE',2*NBNISO,3,IBASE(IHLIB))
          TEXT8='EDITING '
          JSO=IHLIB 
          DO 201 ISO=1,NBNISO
            READ(TEXT8,'(2A4)') IBASE(JSO),IBASE(JSO+1)
            JSO=JSO+2   
 201      CONTINUE       
          CALL LCMPUT(IPEDIT,'ILIBRARYNAME',2*NBNISO,3,IBASE(IHLIB))
          TEXT8='        '
          JSO=IHLIB 
          DO 202 ISO=1,NBNISO
            READ(TEXT8,'(2A4)') IBASE(JSO),IBASE(JSO+1)
            JSO=JSO+2   
 202      CONTINUE       
          CALL LCMPUT(IPEDIT,'ISOTOPESCOH ',2*NBNISO,3,IBASE(IHLIB))
          CALL LCMPUT(IPEDIT,'ISOTOPESINC ',2*NBNISO,3,IBASE(IHLIB))
          CALL LCMPUT(IPEDIT,'ISOTOPESHIN ',2*NBNISO,3,IBASE(IHLIB))
          CALL XDRSET(IBASE(IHLIB),NBNISO,0)
          CALL LCMPUT(IPEDIT,'ISOTOPESNTFG',NBNISO,1,IBASE(IHLIB))
          CALL LCMPUT(IPEDIT,'ISOTOPESSHI ',NBNISO,1,IBASE(IHLIB))
        ENDIF
      ENDIF
      CALL RLSARA(IBASE(IHLIB))
      RETURN
      END
