*DECK LELCSY
      LOGICAL FUNCTION LELCSY(IPGEOM,GEOCV ,IGT   )
C----
C 
C           NAME: LELCSY
C      COMPONENT: EXCELL
C          LEVEL: 3 (CALLED BY 'XELDCL')
C        VERSION: 1.0
C       CREATION: 2001/04/27
C         AUTHOR: G. MARLEAU
C            USE: VERIFY IF GEOMETRY SATISFIES AN INTRINSIC 
C                 SYMMETRY
C
C VARIABLES 
C   IPGEOM / GEOMETRY STRICTURE POINTER                   /I./INTEGER     
C   GEOCV  / GEOMETRY NAME                                /I./C*12
C   IGT    / GEOMETRY TURN NUMBER                         /I./INTEGER(2) 
C   LELCSY / TRUE IF SYMMETRY IS VALID                    /.O/LOGICAL  
C----
      IMPLICIT          NONE
C----
C  PARAMETERS
C---- 
      INTEGER           IPGEOM
      CHARACTER*12      GEOCV
      INTEGER           IGT(2)
      CHARACTER*3       CSY
C----
C  MEMORY ALLOCATION
C----
      INTEGER           IBASE(1)
      REAL              RBASE
      COMMON            RBASE(1)
      EQUIVALENCE      (RBASE(1),IBASE(1))
      INTEGER           IMESH,ISPLT,IMIX,
     >                  IMESH1,ISPLT1,IMIX1,
     >                  IMESHT(2),ISPLTT(2),IMIXT(2)
C----
C  LOCAL PAREMATER
C---- 
      INTEGER            NSTATE
      INTEGER            IOUT   
      CHARACTER*6        NAMSBR
      PARAMETER         (NSTATE=20,IOUT=6,NAMSBR='LELCSY')
      INTEGER            ISTATE(NSTATE),IKT(2)
      INTEGER            NR,NX,NY,NZ,NK,NXYZ,
     >                   NTX(2),NTY(2),NTZ(2)
      REAL               OFFCEN(3),OFFTR(3,2)
      INTEGER            ILCMLN,ILCMTY
      INTEGER            IMX,IMY,IMZ,ISX,ISY,ISZ,IG,
     >                   ITMX,ITMY,ITMZ,ITSX,ITSY,ITSZ,ITMIX,
     >                   ITMI,IDMI,IR,IX,IY,IZ,IM1,IM2,IS1,IS2 
      LELCSY=.TRUE. 
C----
C  READ GEOMETRY INFORMATION
C----  
      CALL LCMSIX(IPGEOM,GEOCV,1)
C-- STATE-VECTOR
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      NR=ISTATE(2)
      NX=ISTATE(3)
      NY=ISTATE(4)
      NZ=ISTATE(5)
      NK=ISTATE(6)
      NXYZ=MAX(NX,NY,NZ)
      CALL SETARA(RBASE,3*(NXYZ+1),IMESH)
      CALL XDRSET(RBASE(IMESH),3*(NXYZ+1),0.0)
      IMX=IMESH 
      IMY=IMX+NXYZ+1 
      IMZ=IMY+NXYZ+1 
      CALL SETARA(IBASE,3*NXYZ,ISPLT)
      CALL XDRSET(IBASE(ISPLT),3*NXYZ,1)
      ISX=ISPLT 
      ISY=ISX+NXYZ 
      ISZ=ISY+NXYZ 
      CALL SETARA(IBASE,NK  ,IMIX)    
      CALL XDRSET(IBASE(IMIX),NK,0)
C-- MESHX
      CALL LCMLEN(IPGEOM,'MESHX       ',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. NX+1)
     >  CALL LCMGET(IPGEOM,'MESHX       ',RBASE(IMX)) 
C-- SPLITX
      CALL LCMLEN(IPGEOM,'SPLITX      ',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. NX)
     >  CALL LCMGET(IPGEOM,'SPLITX      ',IBASE(ISX)) 
C-- MESHY
      CALL LCMLEN(IPGEOM,'MESHY       ',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. NY+1)
     >  CALL LCMGET(IPGEOM,'MESHY       ',RBASE(IMY)) 
C-- SPLITY
      CALL LCMLEN(IPGEOM,'SPLITY      ',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. NY)
     >  CALL LCMGET(IPGEOM,'SPLITY      ',IBASE(ISY)) 
      IF(NZ .GT. 0) THEN
C-- MESHZ
        CALL LCMLEN(IPGEOM,'MESHZ       ',ILCMLN,ILCMTY)
        IF(ILCMLN .EQ. NZ+1) 
     >    CALL LCMGET(IPGEOM,'MESHZ       ',RBASE(IMZ))
C-- SPLITZ
        CALL LCMLEN(IPGEOM,'SPLITZ      ',ILCMLN,ILCMTY)
        IF(ILCMLN .EQ. NZ) 
     >   CALL LCMGET(IPGEOM,'SPLITZ      ',IBASE(ISZ))
      ELSE
        NZ=1
      ENDIF
C-- MIX
      CALL LCMLEN(IPGEOM,'MIX         ',ILCMLN,ILCMTY)
      IF(ILCMLN .GT. 0 .AND. ILCMLN .LE. NK)
     >  CALL LCMGET(IPGEOM,'MIX         ',IBASE(IMIX))
C- OFF CENTER 
      CALL XDRSET(OFFCEN,3,0.0)
      CALL LCMLEN(IPGEOM,'OFFCENTER   ',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. 3)
     >  CALL LCMGET(IPGEOM,'OFFCENTER   ',OFFCEN)
C----
C  PRINT INITIAL MESH
C----
C        WRITE(6,*) 'ANALYZING GEOMETRY =',GEOCV,IGT(1),IGT(2)
C        WRITE(6,*) 'Dimensions =',nx,ny,nz,nr,nk
C        WRITE(6,6001) 'MESHX ='
C        WRITE(6,6002) (RBASE(IMX+IX),IX=0,NX)
C        WRITE(6,6001) 'SPLTX ='
C        WRITE(6,6003) (IBASE(ISX+IX),IX=0,NX-1)
C        WRITE(6,6001) 'MESHY ='
C        WRITE(6,6002) (RBASE(IMY+IY),IY=0,NY)
C        WRITE(6,6001) 'SPLTY ='
C        WRITE(6,6003) (IBASE(ISY+IY),IY=0,NY-1)
C        WRITE(6,6001) 'MESHZ ='
C        WRITE(6,6002) (RBASE(IMZ+IZ),IZ=0,NZ)
C        WRITE(6,6001) 'SPLTZ ='
C        WRITE(6,6003) (IBASE(ISZ+IZ),IZ=0,NZ-1)
C        WRITE(6,6001) 'MIXT  ='
C        WRITE(6,6003) (IBASE(IMIX+IX),IX=0,NK-1)
C        WRITE(6,6001) 'OFFC  ='
C        WRITE(6,6002) (OFFCEN(IX),IX=1,3)
C----
C  TURN GEOMETRY WITH IGT
C---- 
      DO 10 IG=1,2
        IF(IGT(IG) .GT. 12 ) THEN
          IKT(IG)=12-IGT(IG)
        ELSE
          IKT(IG)=IGT(IG)
        ENDIF
        CALL SETARA(RBASE,3*NXYZ,IMESH1)
        IMESHT(IG)=IMESH1
        CALL XDRSET(RBASE(IMESH1),3*NXYZ,0.0)
        CALL SETARA(RBASE,3*NXYZ,ISPLT1)
        ISPLTT(IG)=ISPLT1
        CALL XDRSET(IBASE(ISPLT1),3*NXYZ,0)
        CALL SETARA(IBASE,NK  ,IMIX1)
        IMIXT(IG)=IMIX1    
        CALL XDRSET(IBASE(IMIX1),NK,0)
        ITMX=IMESH1 
        ITMY=ITMX+NXYZ+1 
        ITMZ=ITMY+NXYZ+1 
        ITSX=ISPLT1 
        ITSY=ITSX+NXYZ 
        ITSZ=ITSY+NXYZ 
        IF(IKT(IG) .LT. 0) THEN 
          OFFTR(3,IG)=-OFFCEN(3)
        ELSE
          OFFTR(3,IG)=OFFCEN(3)
        ENDIF
        IF     (ABS(IKT(IG)) .EQ. 1) THEN
          NTX(IG)=NX
          NTY(IG)=NY
          NTZ(IG)=NZ
          DO 100 IX=0,NX-1 
            RBASE(ITMX+IX)=RBASE(IMX+IX+1)-RBASE(IMX+IX)
            IBASE(ITSX+IX)=IBASE(ISX+IX)
 100      CONTINUE
          DO 110 IY=0,NY-1
            RBASE(ITMY+IY)=RBASE(IMY+IY+1)-RBASE(IMY+IY)
            IBASE(ITSY+IY)=IBASE(ISY+IY)
 110      CONTINUE
          OFFTR(1,IG)=OFFCEN(1)
          OFFTR(2,IG)=OFFCEN(2)
          IF(IKT(IG) .LT. 0) THEN
            DO 120 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              ITMI=IZ*NX*NY*(NR+1)
              IDMI=(NZ-IZ-1)*NX*NY*(NR+1)
              DO 121 IY=0,NY-1
                DO 122 IX=0,NX-1
                  DO 123 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 123              CONTINUE
 122            CONTINUE
 121          CONTINUE
 120        CONTINUE
          ELSE
            DO 130 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              ITMI=IZ*NX*NY*(NR+1)
              IDMI=ITMI
              DO 131 IY=0,NY-1
                DO 132 IX=0,NX-1
                  DO 133 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 133              CONTINUE
 132            CONTINUE
 131          CONTINUE
 130        CONTINUE
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 2) THEN 
C----
C  ROTATION OF PI/2 
C----
          NTX(IG)=NY
          NTY(IG)=NX
          NTZ(IG)=NZ
          DO 200 IX=0,NY-1 
            RBASE(ITMX+IX)=RBASE(IMY+IX+1)-RBASE(IMY+IX)
            IBASE(ITSX+IX)=IBASE(ISY+IX)
 200      CONTINUE
          DO 210 IY=0,NX-1
            RBASE(ITMY+IY)=RBASE(IMX+NX-IY)-RBASE(IMX+NX-IY-1)
            IBASE(ITSY+IY)=IBASE(ISX+NX-IY-1)
 210      CONTINUE
          OFFTR(1,IG)=OFFCEN(2)
          OFFTR(2,IG)=-OFFCEN(1)
          IF(IKT(IG) .LT. 0) THEN
            DO 220 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 221 IY=0,NX-1
                DO 222 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+(NY-IX-1)*NX*(NR+1)+
     >                 IY*(NR+1)
                  DO 223 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 223              CONTINUE
 222            CONTINUE
 221          CONTINUE
 220        CONTINUE
          ELSE
            DO 230 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 231 IY=0,NX-1
                DO 232 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=IZ*NX*NY*(NR+1)+(NY-IX-1)*NX*(NR+1)+
     >                 IY*(NR+1)
                  DO 233 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 233              CONTINUE
 232            CONTINUE
 231          CONTINUE
 230        CONTINUE 
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 3) THEN
C----
C  ROTATION OF PI 
C----
          NTX(IG)=NX
          NTY(IG)=NY
          NTZ(IG)=NZ
          DO 300 IX=0,NX-1 
            RBASE(ITMX+IX)=RBASE(IMX+NX-IX)-RBASE(IMX+NX-IX-1)
            IBASE(ITSX+IX)=IBASE(ISX+NX-IX-1)
 300      CONTINUE
          DO 310 IY=0,NY-1
            RBASE(ITMY+IY)=RBASE(IMY+NY-IY)-RBASE(IMY+NY-IY-1)
            IBASE(ITSY+IY)=IBASE(ISY+NY-IY-1)
 310      CONTINUE
          OFFTR(1,IG)=-OFFCEN(1)
          OFFTR(2,IG)=-OFFCEN(2)
          IF(IKT(IG) .LT. 0) THEN
            DO 320 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 321 IY=0,NY-1
                DO 322 IX=0,NX-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+(NY-IY-1)*NX*(NR+1)+
     >                 (NX-IX-1)*(NR+1)
                  DO 323 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 323              CONTINUE
 322            CONTINUE
 321          CONTINUE
 320        CONTINUE
          ELSE
            DO 330 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 331 IY=0,NY-1
                DO 332 IX=0,NX-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=IZ*NX*NY*(NR+1)+(NY-IY-1)*NX*(NR+1)+
     >                 (NX-IX-1)*(NR+1)
                  DO 333 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 333              CONTINUE
 332            CONTINUE
 331          CONTINUE
 330        CONTINUE
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 4) THEN
C----
C  ROTATION OF 3*PI/2 
C----
          NTX(IG)=NY
          NTY(IG)=NX
          NTZ(IG)=NZ
          DO 400 IX=0,NY-1 
            RBASE(ITMX+IX)=RBASE(IMY+NY-IX)-RBASE(IMY+NY-IX-1)
            IBASE(ITSX+IX)=IBASE(ISY+NY-IX-1)
 400      CONTINUE
          DO 410 IY=0,NX-1
            RBASE(ITMY+IY)=RBASE(IMX+IY+1)-RBASE(IMX+IY)
            IBASE(ITSY+IY)=IBASE(ISX+IY)
 410      CONTINUE
          OFFTR(1,IG)=-OFFCEN(2)
          OFFTR(2,IG)=OFFCEN(1)
          IF(IKT(IG) .LT. 0) THEN
            DO 420 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 421 IY=0,NX-1
                DO 422 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+(NY-IX-1)*NX*(NR+1)+
     >                 IY*(NR+1)
                  DO 423 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 423              CONTINUE
 422            CONTINUE
 421          CONTINUE
 420        CONTINUE
          ELSE
            DO 430 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 431 IY=0,NX-1
                DO 432 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=IZ*NX*NY*(NR+1)+(NY-IX-1)*NX*(NR+1)+
     >                 IY*(NR+1)
                  DO 433 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 433              CONTINUE
 432            CONTINUE
 431          CONTINUE
 430        CONTINUE
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 5) THEN
C----
C  REFLECTION WITH RESPECT TO AXIS  // TO Y
C----
          NTX(IG)=NX
          NTY(IG)=NY
          NTZ(IG)=NZ
          DO 500 IX=0,NX-1 
            RBASE(ITMX+IX)=RBASE(IMX+NX-IX)-RBASE(IMX+NX-IX-1)
            IBASE(ITSX+IX)=IBASE(ISX+NX-IX-1)
 500      CONTINUE
          DO 510 IY=0,NY-1
            RBASE(ITMY+IY)=RBASE(IMY+IY+1)-RBASE(IMY+IY)
            IBASE(ITSY+IY)=IBASE(ISY+IY)
 510      CONTINUE
          OFFTR(1,IG)=-OFFCEN(1)
          OFFTR(2,IG)=OFFCEN(2)
          IF(IKT(IG) .LT. 0) THEN
            DO 520 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 521 IY=0,NY-1
                DO 522 IX=0,NX-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+IY*NX*(NR+1)+
     >                 (NX-IX-1)*(NR+1)
                  DO 523 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 523              CONTINUE
 522            CONTINUE
 521          CONTINUE
 520        CONTINUE
          ELSE
            DO 530 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 531 IY=0,NY-1
                DO 532 IX=0,NX-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)+
     >                 (NX-IX-1)*(NR+1)
                  DO 533 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 533              CONTINUE
 532            CONTINUE
 531          CONTINUE
 530        CONTINUE
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 6) THEN
C----
C  ROTATION OF PI/2 FOLLOWED BY 
C  REFLECTION WITH RESPECT TO AXIS  // TO Y
C----
          NTX(IG)=NY
          NTY(IG)=NX
          NTZ(IG)=NZ
          DO 600 IX=0,NY-1 
            RBASE(ITMX+IX)=RBASE(IMY+IX+1)-RBASE(IMY+IX)
            IBASE(ITSX+IX)=IBASE(ISY+IX)
 600      CONTINUE
          DO 610 IY=0,NX-1
            RBASE(ITMY+IY)=RBASE(IMX+IY+1)-RBASE(IMX+IY)
            IBASE(ITSY+IY)=IBASE(ISX+IY)
 610      CONTINUE
          OFFTR(1,IG)=OFFCEN(2)
          OFFTR(2,IG)=OFFCEN(1)
          IF(IKT(IG) .LT. 0) THEN
            DO 620 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 621 IY=0,NX-1
                DO 622 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+IX*NX*(NR+1)+
     >                 IY*(NR+1)
                  DO 623 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 623              CONTINUE
 622            CONTINUE
 621          CONTINUE
 620        CONTINUE
          ELSE
            DO 630 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 631 IY=0,NX-1
                DO 632 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=IZ*NX*NY*(NR+1)+IX*NX*(NR+1)+
     >                 IY*(NR+1)
                  DO 633 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 633              CONTINUE
 632            CONTINUE
 631          CONTINUE
 630        CONTINUE 
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 7) THEN
C----
C  REFLECTION WITH RESPECT TO AXIS // TO X
C----
          NTX(IG)=NX
          NTY(IG)=NY
          NTZ(IG)=NZ
          DO 700 IX=0,NX-1 
            RBASE(ITMX+IX)=RBASE(IMX+IX+1)-RBASE(IMX+IX)
            IBASE(ITSX+IX)=IBASE(ISX+IX)
 700      CONTINUE
          DO 710 IY=0,NY-1
            RBASE(ITMY+IY)=RBASE(IMY+NY-IY)-RBASE(IMY+NY-IY-1)
            IBASE(ITSY+IY)=IBASE(ISY+NY-IY-1)
 710      CONTINUE
          OFFTR(1,IG)=OFFCEN(1)
          OFFTR(2,IG)=-OFFCEN(2)
          IF(IKT(IG) .LT. 0) THEN
            DO 720 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 721 IY=0,NY-1
                ITMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)
                IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+(NY-IY-1)*NX*(NR+1)
                DO 722 IX=0,NX-1
                  DO 723 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 723              CONTINUE
 722            CONTINUE
 721          CONTINUE
 720        CONTINUE
          ELSE
            DO 730 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 731 IY=0,NY-1
                ITMI=IZ*NX*NY*(NR+1)+IY*NX*(NR+1)
                IDMI=IZ*NX*NY*(NR+1)+(NY-IY-1)*NX*(NR+1)
                DO 732 IX=0,NX-1
                  DO 733 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 733              CONTINUE
 732            CONTINUE
 731          CONTINUE
 730        CONTINUE
          ENDIF
        ELSE IF(ABS(IKT(IG)) .EQ. 8) THEN
C----
C  ROTATION OF PI/2 FOLLOWED BY
C  REFLECTION WITH RESPECT TO AXIS // TO X
C----
          NTX(IG)=NY
          NTY(IG)=NX
          NTZ(IG)=NZ
          DO 800 IX=0,NY-1 
            RBASE(ITMX+IX)=RBASE(IMY+NY-IX)-RBASE(IMY+NY-IX-1)
            IBASE(ITSX+IX)=IBASE(ISY+NY-IX-1)
 800      CONTINUE
          DO 810 IY=0,NX-1
            RBASE(ITMY+IY)=RBASE(IMX+NX-IY)-RBASE(IMX+NX-IY-1)
            IBASE(ITSY+IY)=IBASE(ISX+NX-IY-1)
 810      CONTINUE
          OFFTR(1,IG)=-OFFCEN(2)
          OFFTR(2,IG)=-OFFCEN(1)
          IF(IKT(IG) .LT. 0) THEN
            DO 820 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+NZ-IZ)-RBASE(IMZ+NZ-IZ-1)
              IBASE(ITSZ+IZ)=IBASE(ISZ+NZ-IZ-1)
              DO 821 IY=0,NX-1
                DO 822 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=(NZ-IZ-1)*NX*NY*(NR+1)+(NY-IX-1)*NX*(NR+1)+
     >                 (NX-IY-1)*(NR+1)
                  DO 823 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 823              CONTINUE
 822            CONTINUE
 821          CONTINUE
 820        CONTINUE
          ELSE
            DO 830 IZ=0,NZ-1
              RBASE(ITMZ+IZ)=RBASE(IMZ+IZ+1)-RBASE(IMZ+IZ)
              IBASE(ITSZ+IZ)=IBASE(ISZ+IZ)
              DO 831 IY=0,NX-1
                DO 832 IX=0,NY-1
                  ITMI=IZ*NX*NY*(NR+1)+IY*NY*(NR+1)+
     >                 IX*(NR+1)
                  IDMI=IZ*NX*NY*(NR+1)+(NY-IX-1)*NX*(NR+1)+
     >                 (NX-IY-1)*(NR+1)
                  DO 833 IR=0,NR
                    IBASE(IMIX1+ITMI)=IBASE(IMIX+IDMI)
                    ITMI=ITMI+1
                    IDMI=IDMI+1
 833              CONTINUE
 832            CONTINUE
 831          CONTINUE
 830        CONTINUE 
          ENDIF
        ENDIF
C----
C  PRINT TURNED MESH
C----
C        WRITE(6,6000) IG,IKT(IG)
C        WRITE(6,6001) 'MESHX ='
C        WRITE(6,6002) (RBASE(ITMX+IX),IX=0,NTX(IG)-1)
C        WRITE(6,6001) 'SPLTX ='
C        WRITE(6,6003) (IBASE(ITSX+IX),IX=0,NTX(IG)-1)
C        WRITE(6,6001) 'MESHY ='
C        WRITE(6,6002) (RBASE(ITMY+IY),IY=0,NTY(IG)-1)
C        WRITE(6,6001) 'SPLTY ='
C        WRITE(6,6003) (IBASE(ITSY+IY),IY=0,NTY(IG)-1)
C        WRITE(6,6001) 'MESHZ ='
C        WRITE(6,6002) (RBASE(ITMZ+IZ),IZ=0,NTZ(IG)-1)
C        WRITE(6,6001) 'SPLTZ ='
C        WRITE(6,6003) (IBASE(ITSZ+IZ),IZ=0,NTZ(IG)-1)
C        WRITE(6,6001) 'MIXT  ='
C        WRITE(6,6003) (IBASE(IMIX1+IX),IX=0,NK-1)
C        WRITE(6,6001) 'OFFC  ='
C        WRITE(6,6002) (OFFTR(IX,IG),IX=1,3)
 10   CONTINUE
C----
C  COMPARE GEOMETRY
C  1- MESH AND SPLIT IN X, Y AND Z
C  2- MIXTURES
C  3- OFFCENTER
C---- 
      IF(NTX(1) .EQ. NTX(2)) THEN
        IM1=IMESHT(1)
        IM2=IMESHT(2)
        IS1=ISPLTT(1)
        IS2=ISPLTT(2)
        DO 900 IX=0,NTX(1)-1
          IF(RBASE(IM1+IX) .NE. RBASE(IM2+IX) .OR.
     >       IBASE(IS1+IX) .NE. IBASE(IS2+IX) ) THEN
            LELCSY=.FALSE.
            GO TO 995
          ENDIF
 900    CONTINUE
      ELSE
        LELCSY=.FALSE.
        GO TO 995
      ENDIF
      IF(NTY(1) .EQ. NTY(2)) THEN
        IM1=IM1+NTX(1)
        IM2=IM2+NTX(2)
        IS1=IS1+NTX(1)
        IS2=IS2+NTX(2)
        DO 910 IY=0,NTY(1)-1
          IF(RBASE(IM1+IY) .NE. RBASE(IM2+IY) .OR.
     >       IBASE(IS1+IY) .NE. IBASE(IS2+IY) ) THEN
            LELCSY=.FALSE.
            GO TO 995
          ENDIF
 910    CONTINUE
      ELSE
        LELCSY=.FALSE.
        GO TO 995
      ENDIF
      IF(NTZ(1) .EQ. NTZ(2)) THEN
        IM1=IM1+NTY(1)
        IM2=IM2+NTY(2)
        IS1=IS1+NTY(1)
        IS2=IS2+NTY(2)
        DO 920 IZ=0,NTZ(1)-1
          IF(RBASE(IM1+IZ) .NE. RBASE(IM2+IZ) .OR.
     >       IBASE(IS1+IZ) .NE. IBASE(IS2+IZ) ) THEN
            LELCSY=.FALSE.
            GO TO 995
          ENDIF
 920    CONTINUE
      ELSE
        LELCSY=.FALSE.
        GO TO 995
      ENDIF
      IM1=IMIXT(1)
      IM2=IMIXT(2)
      DO 930 IX=0,NK-1
        IF(IBASE(IM1+IX) .NE. IBASE(IM2+IX) ) THEN
          LELCSY=.FALSE.
          GO TO 995
        ENDIF
 930  CONTINUE
      IF(OFFTR(1,1) .NE. OFFTR(1,2) .OR.
     >   OFFTR(2,1) .NE. OFFTR(2,2) .OR.   
     >   OFFTR(3,1) .NE. OFFTR(3,2) ) THEN
        LELCSY=.FALSE.
        GO TO 995
      ENDIF
 995  CONTINUE
C----
C  RELEASE MEMORY
C----
      IM2=IMIXT(2)
      CALL RLSARA(IBASE(IM2))
      IS2=ISPLTT(2)
      CALL RLSARA(IBASE(IS2))
      IM2=IMESHT(2)
      CALL RLSARA(RBASE(IM2))
      IM1=IMIXT(1)
      CALL RLSARA(IBASE(IM1))
      IS1=ISPLTT(1)
      CALL RLSARA(IBASE(IS1))
      IM1=IMESHT(1)
      CALL RLSARA(RBASE(IM1))
      CALL RLSARA(IBASE(IMIX))    
      CALL RLSARA(IBASE(ISPLT))
      CALL RLSARA(RBASE(IMESH))
      CALL LCMSIX(IPGEOM,GEOCV,2)
C----
C  RETURN 
C----
      RETURN
C----
C  FORMATS
C----
C 6000 FORMAT(' LELCSY ',2I4)
C 6001 FORMAT(1X,A7)
C 6002 FORMAT(5F10.5)
C 6003 FORMAT(5I10)
      END
